use crate::rentry::{build_client, delete_paste, CSRFData};

mod rentry;

const PASTE_NAME: &str = "Hyprland-controversy";

fn main() {
    let client = build_client();
    let csrf_data = CSRFData::get(&client, PASTE_NAME);

    let edit_code = "f";
    match delete_paste(&client, &csrf_data, edit_code, PASTE_NAME) {
        Ok(_) => println!("Paste deleted successfully"),
        Err(e) => match e {
            rentry::DeleteError::RequestFailure(msg) => eprintln!("Request error (non 2XX): {msg}"),
            rentry::DeleteError::UnexpectedRedirect(msg) => eprintln!("Unexpected redirect: {msg}"),
            rentry::DeleteError::FormError(msg) => {
                if msg == "Invalid edit code." {
                    eprintln!("Invalid edit code")
                } else {
                    eprintln!("Form error: {msg}")
                }
            }
            rentry::DeleteError::UnknownFailure(msg) => eprintln!("Unknown failure: {msg}"),
            rentry::DeleteError::ReqwestError(e) => eprintln!("Request failed with: {e:?}"),
        },
    }
}
